"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Field = /** @class */ (function (_super) {
    __extends(Field, _super);
    function Field(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { newValue: props.value };
        _this.onChange = _this.onChange.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        return _this;
    }
    Field.prototype.onChange = function (e) {
        var newValue = e.target.value;
        var validationErrors = this.validate(newValue);
        console.debug("validationErrors", validationErrors);
        this.setState(__assign({}, this.state, { validationErrors: validationErrors, newValue: newValue }));
        // this.setState({...this.state,newValue:e.target.value});
    };
    Field.prototype.onBlur = function (e) {
        var newValue = e.target.value;
        var validationErrors = this.validate(newValue);
        console.debug("validationErrors", validationErrors);
        this.setState(__assign({}, this.state, { validationErrors: validationErrors }));
    };
    Field.prototype.validate = function (value) {
        if (this.props.required) {
            if (!value)
                return "This is a mandatory filed!";
            var oneRadioIsChecked = false;
            if (this.props.inputType === "radio") {
                var radios = document.getElementsByName(this.props.name);
                for (var i = 0, length_1 = radios.length; i < length_1; i++) {
                    if (radios[i].checked) {
                        // do whatever you want with the checked radio
                        oneRadioIsChecked = true;
                        // only one radio can be logically checked, don't check the rest
                        break;
                    }
                }
                if (!oneRadioIsChecked)
                    return "This is a mandatory filed!";
            }
        }
        if (this.props.validator) {
            var customErr = this.props.validator(value);
            if (customErr)
                this.inner_input.setCustomValidity(customErr);
            else
                this.inner_input.setCustomValidity("");
            return customErr;
        }
        return undefined;
    };
    Field.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: "field" },
            React.createElement("div", { className: "fieldContent" },
                React.createElement("span", { className: "title" }, this.props.title),
                React.createElement("input", { ref: function (input) { return _this.inner_input = input; }, type: this.props.inputType, name: this.props.name, onChange: this.onChange, onBlur: this.onBlur, value: this.state.newValue, required: this.props.required, disabled: this.props.disabled })),
            this.state.validationErrors ?
                React.createElement("div", { className: "validationErr" },
                    React.createElement("span", null, this.state.validationErrors))
                :
                    ""));
    };
    return Field;
}(React.Component));
exports.Field = Field;
//# sourceMappingURL=Field.js.map